#include <tizen.h>
#include <service_app.h>
#include "$(appName).h"

extern void init_thing();

/**
 * @brief Hook to take necessary actions before main event loop starts.
 * Initialize the service's data.
 * If this function returns true, the main loop of the service starts.
 * If this function returns false, the service is terminated.
 */
static bool srv_create(void *user_data)
{
	FN_CALL;

	return true;
}

/**
 * @brief This callback function is called when another application.
 * sends the launch request to the service.
 */
static void srv_control(app_control_h app_control, void *user_data)
{
	/* Handle the launch request. */

	FN_CALL;

	init_thing();

	return;
}

/**
 * @brief This callback function is called once after the main loop.
 * of the service exits.
 */
static void srv_terminate(void *user_data)
{
	/* Release all resources. */

	FN_CALL;

	return;
}

int main(int argc, char *argv[])
{
	FN_CALL;

	int ret;

	service_app_lifecycle_callback_s event_callback = {0, };

	event_callback.create = srv_create;
	event_callback.terminate = srv_terminate;
	event_callback.app_control = srv_control;

	ret = service_app_main(argc, argv, &event_callback, NULL);
	if (ret != APP_ERROR_NONE)
		dlog_print(DLOG_ERROR, LOG_TAG, "service_app_main() is failed. err = %d", ret);

	return ret;
}
